? create-swank-server.diff
Index: swank.lisp
===================================================================
RCS file: /project/slime/cvsroot/slime/swank.lisp,v
retrieving revision 1.100
diff -u -d -u -r1.100 swank.lisp
--- swank.lisp	16 Jan 2004 07:26:13 -0000	1.100
+++ swank.lisp	16 Jan 2004 11:32:30 -0000
@@ -175,21 +175,31 @@
 (defvar *use-dedicated-output-stream* t)
 (defvar *swank-in-background* nil)
 
+(defun create-swank-server (&optional (port 0))
+  (setq *write-lock* (make-lock :name "Swank write lock"))
+  (let ((socket (create-socket port)))
+    (prog1
+        (local-port socket)
+      (spawn (lambda () (setup-server socket nil))
+             :name "Swank"))))
+
 (defun start-server (port-file)
   (setq *write-lock* (make-lock :name "Swank write lock"))
   (if (eq *swank-in-background* :spawn)
-      (spawn (lambda () (setup-server port-file nil))
+      (spawn (lambda () (let ((socket (create-socket 0)))
+                          (announce-server-port port-file (local-port socket))
+                          (setup-server socket nil)))
              :name "Swank")
-      (setup-server port-file *swank-in-background*)))
+      (let ((socket (create-socket 0)))
+        (announce-server-port port-file (local-port socket))
+        (setup-server socket *swank-in-background*))))
 
-(defun setup-server (port-file background)
-  (let ((socket (create-socket 0)))
-    (announce-server-port port-file (local-port socket))
-    (let ((client (accept-connection socket)))
-      (close-socket socket)
-      (let ((connection (create-connection client)))
-        (init-main-connection connection)
-        (serve-requests client connection background)))))
+(defun setup-server (socket background)
+  (let ((client (accept-connection socket)))
+    (close-socket socket)
+    (let ((connection (create-connection client)))
+      (init-main-connection connection)
+      (serve-requests client connection background))))
 
 (defun serve-requests (client connection background)
   (ecase background
